! Copyright (C) 2010 J.L. Llanio-Trujillo, J.M.C. Marques, F.B. Pereira
module glob_var
implicit none
save
double precision, allocatable :: qrb(:,:)
integer :: nsite,nrb
end module glob_var

subroutine reading(n)   !(r,v,n)
use glob_var
integer :: n,i,j

open(10,file='qrb.txt',status='old')
read(10,*)nsite
!nsite=4  !number of sites
nrb=n    !15   !number of rigid bodies
allocate (qrb(3*nsite,nrb))

!read the rigid-body frame referenced (qrb) Cartesian coordinates of the sites
open(10,file='qrb.txt',status='old')
do j=1,nsite
   read(10,*)(qrb(i,1),i=3*j-2,3*j)
enddo

!copy qrb coordinates from one rigid-body to all rigid-bodies of the cluster
do j=2,nrb
 do i=1,nsite
   qrb(3*i-2,j)=qrb(3*i-2,1)
   qrb(3*i-1,j)=qrb(3*i-1,1)
   qrb(3*i,j)=qrb(3*i,1)
 enddo
enddo
!do j=1,nrb
!   qrb(1,j)=   0.000000d0  !O site--> 1
!   qrb(2,j)=   0.068927d0
!   qrb(3,j)=   0.000000d0

!   qrb(4,j)=   0.756950d0  !H site --> 2
!   qrb(5,j)=  -0.516955d0 
!   qrb(6,j)=   0.000000d0

!   qrb(7,j)=  -0.756950d0  !H site --> 3
!   qrb(8,j)=  -0.516955d0
!   qrb(9,j)=   0.000000d0

!   qrb(10,j)=  0.000000d0  !X site --> 4
!   qrb(11,j)= -0.081073d0
!   qrb(12,j)=  0.000000d0
!enddo
end subroutine reading


!This routine calls the objective function and performs local minimization
subroutine eval_f(x,fit,m)
use glob_var
!implicit none
!integer :: i,n,m
integer :: flag,m,opt
integer :: iter
double precision :: fit
double precision, parameter :: EPS=1.0d-4
double precision :: x(m)
!call objective function
!call object_f(x,fit,m)  
!opt=0
!optimizao local
opt=1
iter=5000
call sdrive(x, m, qrb, nsite, nrb, fit, iter, flag, EPS,opt)
!write(8,*)fit,iter,flag
end subroutine eval_f
